## this lib is part of twitter-spider
##
package require http
package require base64

proc get_twitter_page {name} {
	set tok [http::geturl "http://twitter.com/$name"]
	set res [http::data $tok]
	http::cleanup $tok
	return $res
}

proc get_twitter_friends {name} {
	set page [get_twitter_page $name]
	if {[regexp -nocase -- {<title>Twitter: 404 NOT FOUND</title>} $page] != 0} {
		return {}
	}
	regexp -nocase -- {<div id="friends">.*?</div>} $page friends_raw
	set friends {}
	foreach {foo n} [regexp -nocase -all -inline -- {<a href="http://twitter.com/(.*?)"} $friends_raw] {
		lappend friends $n
		#set friends [concat $friends $n]
	}
	return $friends
}

proc read_cache {} {
	global tree
	set fl [open "log" "r"]
	set data [read $fl]
	close $fl
	set lines [split $data \n]
	foreach line $lines {
		if {[llength $line] <= 0} { break }
		set name [lindex $line 0]
		if {[llength $line] > 1} {
			set tree($name) [lrange $line 1 end]
		} else {
			set tree($name) {}
		}
	}
}

proc rebuild_getlist {} {
	global tree
	global getlist
	foreach key [array names tree] {
		foreach name $tree($key) {
			if {[is_spidered $name] != 1} {
				lappend getlist $name
			}
		}
	}
}

proc is_spidered {name} {
	global tree
	if {[llength [array names tree -exact $name]] > 0} {
		return 1
	}
	return 0
}

proc log_friends {name friends} {
	set fl [open "log" "a+"]
	puts $fl "$name $friends"
	close $fl
}

proc check_tree_friend {name} {
	global tree
	if {[is_spidered $name]} { return }
	
	puts "getting $name..."
	set friends [get_twitter_friends $name]
	puts "    got $friends"
	set tree($name) $friends
	log_friends $name $friends
}

